#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed May 13 14:21:39 2020

@author: parimucha
"""

import sqlite3 as sql

class Database():
    def __init__(self):	
        self.a=1
		#self.database_name=database_name
# =============================================================================
# 		if catalog_type is None:
# 			self.catalog_type='ucac4'
# 		else:
# 			self.catalog_type=catalog_type
# 			
# 		if catalog_path is None:
# 			self.catalog_type='/home/parimucha/Catalogs/'
# 		else:
# 			self.catalog_path=catalog_path
# 		if tmp_dir is None:
# 			self.tmp_dir=''
# 		else:
# 			self.tmp_dir=tmp_dir
# =============================================================================
    
    def Connect(self,name):
        
        stars_database=sql.connect(name, isolation_level='DEFERRED')
        stars_database_cursor=stars_database.cursor()
        return stars_database, stars_database_cursor
    
    def Save_LC(self, db, db_cursor, table, image, a=0,b=0,rewrite=True, min_point=1):
        #observations_database, observations_database_cursor=self.Connect()
        #print(table)
        query  ='CREATE TABLE IF NOT EXISTS stars (USNOB PRIMARY KEY, APASS, VSX, RAJ200, DEJ2000)'
        db_cursor.execute(query)
        db.commit()
      
        #ttt=tuple(table)
        #print(ttt)
        
        values=()
        
        for row in table:
            
            name_usnob=str(row['USNO-B1.0'])
            name_apass=str(row['APASS'])
            name_vsx=str(row['Name'])
            if name_vsx=='0.0':
                name_vsx=' '
             
            ra=float(row['RAJ2000'])
            dec=float(row['DEJ2000'])
            
            # creating table with all observed stars on the frame
            if rewrite:
                db_cursor.execute('INSERT OR REPLACE INTO stars VALUES (?,?,?,?,?)',(name_usnob, name_apass, name_vsx, ra, dec))                
            else:
                db_cursor.execute('INSERT OR IGNORE INTO stars VALUES (?,?,?,?,?)',(name_usnob, name_apass, name_vsx, ra, dec))
            # create table with observations for star
            name='USNOB_'+name_usnob.replace('-','_')
            query='CREATE TABLE IF NOT EXISTS '+name +' (BJD PRIMARY KEY, MAG_CALIB, MAGERR_CALIB, MAG_INS, MAGERR_INST, FILTER, OBSERVATORY, TELESCOPE, CAMERA, TEMPERATURE, EXPTIME)'
            db_cursor.execute(query)
	
            bjd=round(image['BJD'],5)
            mag_calib=round(row['CALIBRATED'],4)
            mag_calib_err=round(row['CALIBRATED_ERR'],4)
            mag_inst=round(row['MAG_AUTO'],4)
            mag_inst_err=round(row['MAGERR_AUTO'],4)
            filter=image['FILTER']
            obs=image['OBSERVATORY']
            tel=image['TELESCOPE']
            camera=image['CAMERA']
            temp=image['TEMPERATURE']
            exp=image['EXPTIME']
            
            if rewrite:
                db_cursor.execute('INSERT OR REPLACE INTO '+name+' VALUES (?,?,?,?,?,?,?,?,?,?,?)', (float(bjd), float(mag_calib), float(mag_calib_err), float(mag_inst), float(mag_inst_err), filter, obs, tel, camera, float(temp), float(exp) ))
            else:
                db_cursor.execute('INSERT OR IGNORE INTO '+name+' VALUES (?,?,?,?,?,?,?,?,?,?,?)', (float(bjd), float(mag_calib), float(mag_calib_err), float(mag_inst), float(mag_inst_err), filter, obs, tel, camera, float(temp), float(exp) )) 
            db.commit()
            
# 
                
                
        else:
            pass
	 
        
        
        db.commit()
        return True
    
    
# =============================================================================
#  def Save_LC_Database(self, database_name, all_stars_table, rewrite=False, min_points=10):
# 		
# 		
# 		
# 		#query  ='CREATE TABLE IF NOT EXISTS observation (jd PRIMARY KEY, date, filename, frame, filter, analysis)'
# 		#observations_database_cursor.execute(query)	
# 		#print(rewrite)
# 		#print(all_stars_table.groups)


# 				##print(star['UCAC4'][0])
# 				##print('Rewriting values in database...')
# 				##print()
# 					for row in range(len(star)):
# 						jd=star['JD_bar'][row]
# 						mag=star['ABS'][row]
# 						mag_error=star['ABS_ERROR'][row]
# 						mag_inst=star['INST'][row]
# 						mag_inst_error=star['INST_ERROR'][row]
# 						mag_comp_aver=star['COMP_AVER'][row]
# 						mag_comp_aver_error=star['COMP_AVER_ERROR'][row]
# 						diff=star['AVER'][row]
# 						diff_error=star['AVER_ERROR'][row]
# 						filter=star['Filter'][row]
# 						nstar=star['Num_Comp'][row]
# 						telescope=star['Telescope'][row]
# 						camera=star['Camera'][row]
# 						observatory=star['Observatory'][row]
# 						exptime=star['Exposure'][row]
# 						temp=star['Temperature'][row]
# 						calibrated=star['Calibrated'][row]				
# 						zero_point=star['ZERO_POINT'][row]
# 				
# 						
# 					number=number+1
# 				
# 			#for star_un in all_stars_table_un.groups:
# 				#name=str('UN__'+star_un['OUR'][0].replace('.','_'))
# 				#sys.stdout.write('\rSaving light curves into database: '+str(number)+'/'+str(num_stars))
# 				#query='CREATE TABLE IF NOT EXISTS '+name +' (JD_bar PRIMARY KEY, mag, mag_error, filter, comp_aver, comp_aver_error, num_comp, zero_point, observatory, telescope, camera, temperature, exptime, calibrated)'
# 				#observations_database_cursor.execute(query)	
# 				#number=number+1
# 				###print(star['UCAC4'][0])
# 				###print('Rewriting values in database...')
# 				###print()
# 				#for row in range(len(star_un)):
# 					#jd=star_un['JD_bar'][row]
# 					#mag=star_un['ABS'][row]
# 					#mag_error=star_un['ABS_ERROR'][row]
# 					#mag_comp_aver=star_un['COMP_AVER'][row]
# 					#mag_comp_aver_error=star_un['COMP_AVER_ERROR'][row]
# 					#filter=star_un['Filter'][row]
# 					#nstar=star_un['Num_Comp'][row]
# 					#telescope=star_un['Telescope'][row]
# 					#camera=star_un['Camera'][row]
# 					#observatory=star_un['Observatory'][row]
# 					#exptime=star_un['Exposure'][row]
# 					#temp=star_un['Temperature'][row]
# 					#calibrated=star_un['Calibrated'][row]				
# 					#zero_point=star['ZERO_POINT'][row]
# 					
# 					#observations_database_cursor.execute('INSERT OR REPLACE INTO '+name+' VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?)',( float(jd), float(mag), float(mag_error), filter, float(mag_comp_aver), float(mag_comp_aver_error), int(nstar), float(zero_point), observatory, telescope, camera, float(temp), float(exptime), calibrated ))
# 			
# 		else:
# 			pass
# 			##query = 'SELECT name FROM sqlite_master WHERE type="table"'
# 			##observations_database_cursor.execute(query)	
# 			##tt=observations_database_cursor.fetchall()
# 			##tables=[]
# 			##for t in tt:
# 				##tables.append(t[0])
# 			
# 			
# 			
# 			#for star in all_stars_table.groups:	
# 				
# 				#name=str('UCAC4_'+star['UCAC4'][0].replace('-','_'))
# 				#ra=float(star['RA'][0])
# 				#dec=float(star['DEC'][0])
# 				#observations_database_cursor.execute('INSERT OR IGNORE INTO stars VALUES (?,?,?)',(name, ra, dec))
# 				
# 				#query='CREATE TABLE IF NOT EXISTS '+name +' (JD_bar PRIMARY KEY, mag, mag_error, filter, comp_aver, comp_aver_error, num_comp, observatory, telescope, camera, temperature, exptime, calibrated)'
# 				#observations_database_cursor.execute(query)	
# 				##print(star['UCAC4'][0])
# 				##if not name in tables:
# 					##print('Creating new table...')
# 				##else:
# 					##print('Table exists')
# 				##print('Inserting values in database')
# 				##print()
# 				#for row in range(len(star)):
# 				
# 					#jd=star['JD_bar'][row]
# 					#mag=star['ABS'][row]
# 					#mag_error=star['ABS_ERROR'][row]
# 					#mag_comp_aver=star['COMP_AVER'][row]
# 					#mag_comp_aver_error=star['COMP_AVER_ERROR'][row]
# 					#filter=star['Filter'][row]
# 					#nstar=star['Num_Comp'][row]
# 					#telescope=star['Telescope'][row]
# 					#camera=star['Camera'][row]
# 					#observatory=star['Observatory'][row]
# 					#exptime=star['Exposure'][row]
# 					#temp=star['Temperature'][row]
# 					#calibrated=star['Calibrated'][row]				
# 				
# 					#observations_database_cursor.execute('INSERT OR IGNORE INTO '+name+' VALUES (?,?,?,?, ?,?,?,?,?, ?, ?,?,?)',(float(jd), float(mag), float(mag_error), filter, float(mag_comp_aver), float(mag_comp_aver_error), int(nstar), observatory, telescope, camera, float(temp), float(exptime), calibrated ))
# 			
# 		observations_database.commit()
# 			#print(query)
# 			
# 			#by_filter=star.group_by(['Filter'])
# 			##print(by_filter)
# 			#print()
# 		
# 				
# 		return 1   
# =============================================================================
